<?php
/**
 * @author    JoomlaShine.com http://www.joomlashine.com
 * @copyright Copyright (C) 2008 - 2011 JoomlaShine.com. All rights reserved.
 * @license   GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 * @version   $Id$
*/
// No direct access
defined('_JEXEC') or die('Restricted index access');

class JElementJSNParams extends JElement
{

	var $_name 					= '';
	var $_value 				= null;
	var $_template_folder_path  = '';
	var $_template_folder_name 	= '';
	var $_node					= null;
	var $_control_name			= '';
	var $_obj_utils				= null;
	var $_template_edition 		= '';
	var $_template_version 		= '';
	var $_template_name 		= '';
	var $_template_copyright	= '';
	var $_template_author		= '';
	var $_template_author_url	= '';
	var $_mootool_version		= '';
	var $_template_gallery_url	= '';
	var $_cacheSensitive		= false;
	var $_proExists 			= false;
	/**
	 * Constructor
	 *
	 */
	function JElementJSNParams()
	{
		$this->_setPhysicalTmplInfo();
		require_once($this->_template_folder_path.DS.'includes'.DS.'lib'.DS.'jsn_utils.php');
		$this->_setUtilsInstance();
		$this->_setTmplInfo();
		$this->_setMootoolVersion();

		// check System cache plugin state
		$this->_cacheSensitive = $this->_obj_utils->checkSystemCache();
	}

	/**
	 * Initialize fectch element
	 *
	 */

	function fetchElement($name, $value, &$node, $control_name)
	{
		$this->_name 			= $name;
		$this->_value 			= $value;
		$this->_node 			= $node;
		$this->_control_name 	= $control_name;
		$subtype 				= $node->attributes('subtype');

		return $this->$subtype();
	}

	/**
	 *
	 * Initialize instance of JSNUtils class
	 */
	function _setUtilsInstance()
	{
		$this->_obj_utils =& JSNUtils::getInstance();
	}

	/**
	 * Initialize Physical template information variable
	 *
	 */
	function _setPhysicalTmplInfo()
	{
		$template_name 					= explode(DS, str_replace(array('\elements', '/elements'), '', dirname(__FILE__)));
		$template_name 					= $template_name [count($template_name) - 1];
		$path_base 						= str_replace(DS."templates".DS.$template_name.DS.'elements', "", dirname(__FILE__));
		$this->_template_folder_path 	= $path_base.DS.'templates'.DS.$template_name;
		$this->_template_folder_name	= $template_name;
	}

	/**
	 * Initialize template information variable
	 *
	 */
	function _setTmplInfo()
	{
		$result 				 	 = $this->_obj_utils->getTemplateDetails();
		$this->_template_edition 	 = $result->edition;
		$this->_template_version 	 = $result->version;
		$this->_template_name 		 = $result->name;
		$this->_template_copyright 	 = $result->copyright;
		$this->_template_author 	 = $result->author;
		$this->_template_author_url  = $result->authorUrl;
		$this->_template_gallery_url = $this->_template_author_url.'/joomla-templates-promo.html';

		$this->_proExists = $this->_obj_utils->checkProEditionExist($this->_template_folder_name, true);
	}

	/**
	 * set mootool version
	 *
	 */
	function _setMootoolVersion()
	{
		$this->_mootool_version = $this->_obj_utils->getMootoolVersion();
	}

	/**
	 * Build modal window
	 *
	 * @param string $name
	 * @param string $url
	 */
	function _buildModalWindow($name, $url, $width = "600", $height = "420")
	{
		JHTML::_('behavior.modal', 'a.jsn-modal');
		$link 	= '<a class="jsn-modal link-button" rel="{handler: \'iframe\', size: {x: '.$width.', y: '.$height.'}}" href="'.$url.'">'.$name.'</a>';
		return $link;
	}

	/**
	 * Create parameter lable
	 *
	 */
	function jsnLabel()
	{
		// check System cache plugin state
		if (!$this->_cacheSensitive && $this->_node->attributes('cachesensitive') == 'yes') return '';

		$tag 		= ($this->_node->attributes('tag') ? $this->_node->attributes('tag') : 'div');
		$class 		= ' class="'.($this->_node->attributes('class') ? $this->_node->attributes('class') : 'jsn-label').'"';
		$alt_class 	= ($this->_node->attributes('altclass') ? ' class="'.$this->_node->attributes('altclass').'"' : '');

		if ($this->_value)
		{
			if ($this->_proExists === false)
			{
				$upgrade_link = '<strong><a class="link-action jsn-modal" rel="{handler: \'iframe\', size: {x: 750, y: 650}}" href="../index.php?template='.strtolower($this->_template_name).'&tmpl=jsn_upgrade">Upgrade now</a></strong>';
			}
			else
			{
				$upgrade_link = '';
			}

			$label = "<$tag$class>"."<span$class>".JText::sprintf($this->_value, $upgrade_link)."</span></$tag>";
			return $label;
		}
		else
		{
			return '<hr />';
		}
	}

	/**
	 * Create parameter panel
	 *
	 */
	function jsnPanel()
	{
		JHTML::stylesheet('jsn_admin.css', JURI::root().'templates/'.$this->_template_folder_name.'/admin/css/');
		JHTML::script('jsn_admin.js', JURI::root().'templates/'.$this->_template_folder_name.'/admin/js/');
		static $count 			= 1;
		$output 				= "";
		$alt_class 				= ($this->_node->attributes('altclass') ? $this->_node->attributes('altclass') : 'none');
		$class 					= 'class="'. ($this->_node->attributes('class') ? $this->_node->attributes('class') : 'title jsn-pane-toggler').'"';
		$opens_table 			= '<table class="paramlist admintable" width="100%" cellspacing="1" border="0"><tbody><tr><td>';
		$close_table 			= '</td></tr></tbody></table>';
		$surround_opens 		= '<div class="jsn-panel">';
		$surround_close 		= '</div>';
		$title 					= '<h3 id="panel-'.$count.'" '.$class.'><span class="toggle-arrow"><span class="param-icon"><span class="'.$alt_class.'">'.JText::_($this->_value).'</span></span></span></h3>';
		$inner_opens 			= '<div class="jsn-pane-slider content">';
		$inner_close 			= '</div>';
		$accordion_opens 		= '';
		$accordion_close 		= '';
		$accordion_condition 	= $this->_node->attributes('position');
		$controller		 		= '';
		if(!defined ('PANEL_CONTROLLER'))
		{
			$controller = '<div class="jsn-controller">';
			$controller .= '<a id="expand-all" href="javascript:void(0);" title="'.JText::_('EXPAND_ALL_PANELS').'">'.JText::_('EXPAND_ALL').'</a>';
			$controller .= '&nbsp;&nbsp;|&nbsp;&nbsp;';
			$controller .= '<a id="collapse-all" href="javascript:void(0);" title="'.JText::_('COLLAPSE_ALL_PANELS').'">'.JText::_('COLLAPSE_ALL').'</a>';
			$controller .= '</div>';

			define('PANEL_CONTROLLER', 1);
		}
		if($accordion_condition == 'first')
		{
			$accordion_opens 	= '<div class="jsn-pane-sliders" id="content-pane" style="width:100%;">';
		}
		$output .= $surround_close;
		if($accordion_condition == 'last')
		{
			$accordion_close 	= '</div>';
		}
		$output = $accordion_close . $close_table . $inner_close . $surround_close . $accordion_opens . $controller . $surround_opens . $title . $inner_opens . $opens_table;
		$count++;
		return $output;
	}

	/**
	 * Create parameter list type
	 *
	 */
	function jsnList()
	{
		$class 		= 'class="'. ($this->_node->attributes('class') ? $this->_node->attributes('class') : 'inputbox').'"';
		$disabled 	= ($this->_node->attributes('disabled') ? 'disabled="'.$this->_node->attributes('disabled').'"' : '');

		// check System cache plugin state
		if ($this->_cacheSensitive && $this->_node->attributes('cachesensitive') == 'yes') $disabled = ' disabled="disabled"';

		$options 	= array ();

		if(count($this->_node->children()))
		{
			foreach ($this->_node->children() as $option)
			{
				$val		= $option->attributes('value');
				$text		= $option->data();
				$options[] 	= JHTML::_('select.option', $val, JText::_($text));
			}
		}

		return JHTML::_('select.genericlist',  $options, $this->_control_name.'['.$this->_name.']', $class.' '.$disabled, 'value', 'text', $this->_value, $this->_control_name.$this->_name);
	}

	/**
	 * Create parameter radio type
	 *
	 */
 	function jsnRadio()
	{
		$class 		= 'class="'. ($this->_node->attributes('class') ? $this->_node->attributes('class') : 'inputbox').'"';
		$disabled 	= ($this->_node->attributes('disabled') ? 'disabled="'.$this->_node->attributes('disabled').'"' : '');

		// check System cache plugin state
		if ($this->_cacheSensitive && $this->_node->attributes('cachesensitive') == 'yes') {
			$disabled = ' disabled="disabled"';
			$this->_value = 0;
		}

		$options 	= array ();

		if(count($this->_node->children()))
		{
			foreach ($this->_node->children() as $option)
			{
				$val		= $option->attributes('value');
				$text		= $option->data();
				$options[] 	= JHTML::_('select.option', $val, JText::_($text));
			}
		}

		return JHTML::_('select.radiolist', $options, ''.$this->_control_name.'['.$this->_name.']', $class.' '.$disabled, 'value', 'text', $this->_value, $this->_control_name.$this->_name);
	}

	/**
	 * Create parameter text box type
	 *
	 */
	function jsnText()
	{
		$size 		= ($this->_node->attributes('size') ? 'size="'.$this->_node->attributes('size').'"' : '');
		$class 		= 'class="'. ($this->_node->attributes('class') ? $this->_node->attributes('class') : 'text_area').'"';
		$disabled 	= ($this->_node->attributes('disabled') ? 'disabled="'.$this->_node->attributes('disabled').'"' : '');
		$value		= htmlspecialchars(html_entity_decode($this->_value, ENT_QUOTES), ENT_QUOTES);
		$posttext	= ($this->_node->attributes('posttext') ? $this->_node->attributes('posttext') : '');

		// check System cache plugin state
		if ($this->_cacheSensitive && $this->_node->attributes('cachesensitive') == 'yes') $disabled = ' disabled="disabled"';

		return '<input type="text" name="'.$this->_control_name.'['.$this->_name.']" id="'.$this->_control_name.$this->_name.'" value="'.$value.'" '.$class.' '.$size.' '.$disabled.' /><span class="jsn-posttext">'.$posttext.'</span>';
	}

	/**
	 * Create parameter text area type
	 *
	 */
	function jsnTextArea()
	{
		$rows 		= $this->_node->attributes('rows');
		$cols 		= $this->_node->attributes('cols');
		$disabled 	= ($this->_node->attributes('disabled') ? 'disabled="'.$this->_node->attributes('disabled').'"' : '');
		$class 		= ($this->_node->attributes('class') ? 'class="'.$this->_node->attributes('class').'"' : 'class="text_area"');
		$value 		= JString::str_ireplace('<br />', "\n", $this->_value);
		return '<textarea name="'.$this->_control_name.'['.$this->_name.']" cols="'.$cols.'" rows="'.$rows.'" '.$class.' id="'.$this->_control_name.$this->_name.'" '.$disabled.'>'.$value.'</textarea>';
	}

	/**
	 * Output sample data installation link
	 *
	 */
	function jsnSampleData()
	{
		$modalURL = '../index.php?template='.JString::strtolower($this->_template_name).'&tmpl=jsn_installsampledata';
		$link 	= $this->_buildModalWindow(JText::_('INSTALL_SAMPLE_DATA'), $modalURL, '750', '650');
		return '<div class="jsn-sampledata">'.JText::_('INSTALL_SAMPLE_DATA_AS_SEEN_ON_DEMO_WEBSITE').'&nbsp;&nbsp;'.$link.'</div>';
	}
	/**
	 * Create check cache folder parameter
	 *
	 */
	function jsnCacheFolder()
	{
		// Load Joomla configuration
		$jconfig 		= new JConfig();

		$size 			= ($this->_node->attributes('size') ? 'size="'.$this->_node->attributes('size').'"' : '');
		$class 			= 'class="'. ($this->_node->attributes('class') ? $this->_node->attributes('class') : 'text_area').'"';
		$value			= htmlspecialchars(html_entity_decode($this->_value, ENT_QUOTES), ENT_QUOTES);
		$root_folder	= JString::str_ireplace('\\', '/', JPATH_ROOT).'/';
		$php_version 	= $this->_node->attributes('phpversion');
		$disabled 		= ($this->_node->attributes('disabled') ? 'disabled="'.$this->_node->attributes('disabled').'"' : '');
		$php_warning 	= '';
		$doc			=& JFactory::getDocument();
		$output			= '';
		$template_name  = JString::strtolower($this->_template_name);
		if (!$disabled)
		{
			if (version_compare(PHP_VERSION, $php_version, '<'))
			{
				$disabled 	= 'disabled="disabled"';
				$php_warning = '<font color="green">['.JText::_('MINIFY_PHP_5_REQUIRED').']</font>';
			}

			if ($this->_mootool_version == '1.1')
			{
				$doc->addScriptDeclaration("
					window.addEvent('domready', function(){
						$('paramscacheFolder').addEvents({
							keyup: function()
							{
								$('paramscacheFolder').fireEvent('hideCheckLink');
							},
							keydown: function()
							{
								$('paramscacheFolder').fireEvent('hideCheckLink');
							},
							hideCheckLink: function()
							{
								if($('paramscacheFolder').value == '')
								{
									$('jsn-checkcache-action').setStyle('visibility', 'hidden');
								} else {
									$('jsn-checkcache-action').setStyle('visibility', 'visible');
								}
							}
						});

						$('jsn-checkcache-action').addEvent('click', function() {
							var actionUrl = '".JURI::root()."index.php?template=$template_name&tmpl=jsn_runajax&task=checkCacheFolder&cache_folder=".$root_folder."'+ $('paramscacheFolder').value;
							var resultMsg = new Element('font');
							var request = new Json.Remote(actionUrl, {
									onComplete: function(jsonObj) {
										$('jsn-checkcache-result').setHTML('');
										if(jsonObj.isDir) {
											if(jsonObj.isWritable) {
												resultMsg.setProperty('color', 'green').setHTML('".JText::_('FOLDER_EXISTS_WRITABLE')."');
											} else {
												resultMsg.setProperty('color', 'red').setHTML('".JText::_('FOLDER_NOT_WRITABLE')."');
											}
										} else {
											resultMsg.setProperty('color', 'red').setHTML('".JText::_('FOLDER_NOT_EXISTS')."');
										}
										resultMsg.injectInside($('jsn-checkcache-result'));
									}
							}).send();
						});
					});
				");
			}
			else if ($this->_mootool_version == '1.2')
			{
				$doc->addScriptDeclaration("
					window.addEvent('domready', function(){
						$('paramscacheFolder').addEvents({
							keyup: function()
							{
								$('paramscacheFolder').fireEvent('hideCheckLink');
							},
							keydown: function()
							{
								$('paramscacheFolder').fireEvent('hideCheckLink');
							},
							hideCheckLink: function()
							{
								if($('paramscacheFolder').value == '')
								{
									$('jsn-checkcache-action').set('styles', {'visibility': 'hidden'});
								} else {
									$('jsn-checkcache-action').set('styles', {'visibility': 'visible'});
								}
							}
						});
						$('jsn-checkcache-action').addEvent('click', function() {
							actionUrl = '".JURI::root()."index.php';
							var resultMsg = new Element('font');
							var jsonRequest = new Request.JSON({url: actionUrl, onSuccess: function(jsonObj){
								$('jsn-checkcache-result').setHTML('');
								if(jsonObj.isDir) {
									if(jsonObj.isWritable) {
										resultMsg.set({color: 'green', text: '".JText::_('FOLDER_EXISTS_WRITABLE')."'});
									} else {
										resultMsg.set({color: 'red', text: '".JText::_('FOLDER_NOT_WRITABLE')."'});
									}
								} else {
									resultMsg.set({color: 'red', text: '".JText::_('FOLDER_NOT_EXISTS')."'});
								}
								resultMsg.inject($('jsn-checkcache-result'));
							}}).get({'template': '".$template_name."', 'tmpl': 'jsn_runajax', 'cache_folder': '".$root_folder."' + $('paramscacheFolder').value , 'task': 'checkCacheFolder'});

						});

					});
				");
			}
			$output = '<input type="text" name="'.$this->_control_name.'['.$this->_name.']" id="'.$this->_control_name.$this->_name.'" value="'.$value.'" '.$class.' '.$size.' '.$disabled.' />&nbsp;'.$php_warning.'&nbsp;<a id="jsn-checkcache-action" class="link-action" href="javascript:void(0)">'.JText::_('CHECK_CACHE_FOLDER').'</a><span id="jsn-checkcache-result"></span>';
		}
		else
		{
			$output = '<input type="text" name="'.$this->_control_name.'['.$this->_name.']" id="'.$this->_control_name.$this->_name.'" value="'.$value.'" '.$class.' '.$size.' '.$disabled.' />&nbsp;'.$php_warning.'&nbsp;<span class="link-disabled">'.JText::_('CHECK_CACHE_FOLDER').'</span>';
		}

		return $output;
	}

	/**
	 * Create About section
	 *
	 */
	function jsnAbout()
	{
		JHTML::_('behavior.modal', 'a.jsn-modal');
		$doc			  		=& JFactory::getDocument();
		$tell_more	      		= '';
		$template_name         	= JString::strtolower($this->_template_name);

		$proExists = $this->_obj_utils->checkProEditionExist($template_name, true);

		if ($this->_mootool_version == '1.1')
		{
				$doc->addScriptDeclaration("
					function checkIntegrity()
					{
						$('jsn-check-integrity').setHTML('');
						$('jsn-check-integrity-result').setHTML('');
					    var resultIntegrityMsg = new Element('span');
						var actionIntegrityUrl = '".JURI::root()."index.php?template=$template_name&tmpl=jsn_runajax&task=checkFilesIntegrity';
						resultIntegrityMsg.setProperty('class', 'jsn-integrity-checking').setHTML('".JText::_('CHECKING', true)."');
						resultIntegrityMsg.injectInside($('jsn-check-integrity-result'));
						var request = new Json.Remote(actionIntegrityUrl, {
								onComplete: function(jsonObj) {
									if(jsonObj.integrity == '1') {
										resultIntegrityMsg.setProperty('class', 'jsn-modification-exist').setHTML('<span>".JText::_('SOME_FILES_HAVE_BEEN_MODIFIED', true).". <a href=\"../index.php?template=".$template_name."&tmpl=jsn_listmodifiedfiles\" class=\"link-action\" id=\"see-file-details\" rel=\"{handler: \'iframe\', size: {x: 570, y:320}}\" onclick=\"SqueezeBox.addClick($(\'see-file-details\')); SqueezeBox.fromElement($(\'see-file-details\')); return false;\">".JText::_('SEE_DETAILS_FILE', true)."</a></span>');
									} else if(jsonObj.integrity == '0') {
										resultIntegrityMsg.setProperty('class', 'jsn-no-modification').setHTML('".JText::_('NO_FILES_MODIFICATION_FOUND', true)."');
									} else {
										resultIntegrityMsg.setProperty('class', 'jsn-no-modification').setHTML('".JText::_('NO_CHECKSUM_FILE_FOUND', true)."');
									}
									resultIntegrityMsg.injectInside($('jsn-check-integrity-result'));
								}
						}).send();
					}
					window.addEvent('domready', function(){
						    $('jsn-check-version').setHTML('');
						    var resultVersionMsg = new Element('span');
							var actionVersionUrl = '".JURI::root()."index.php?template=$template_name&tmpl=jsn_runajax&task=checkVersion';
							resultVersionMsg.setProperty('class', 'jsn-version-checking').setHTML(' - ".JText::_('CHECKING_VERSION', true)."');
							resultVersionMsg.injectInside($('jsn-check-version-result'));
							var request = new Json.Remote(actionVersionUrl, {
									onComplete: function(jsonObj) {
										if(jsonObj.connection  && jsonObj.version != '') {
											if(jsonObj.version == '' || jsonObj.version == '".$this->_template_version."') {
												resultVersionMsg.setProperty('class', 'jsn-latest-version').setHTML('');
											} else {
												resultVersionMsg.setProperty('class', 'jsn-outdated-version').setHTML(' - <a href=\"../index.php?template=".$template_name."&tmpl=jsn_autoupdater\" class=\"link-action\" id=\"jsn-auto-update\" rel=\"{handler: \'iframe\', size: {x: 750, y:680}}\" onclick=\"SqueezeBox.fromElement($(\'jsn-auto-update\'), {parse: \'rel\'}); return false;\">".JText::_('UPDATE_NOW', true)." '+jsonObj.version+'</a>');
											}
										} else {
											resultVersionMsg.setProperty('class', 'jsn-connection-fail').setHTML(' <span class=\"grey\">-</span> ".JText::_('CONNECTION_FAILED', true)."');
										}
										resultVersionMsg.injectInside($('jsn-check-version-result'));
									}
							}).send();
						$('jsn-check-integrity').addEvent('click', function() {checkIntegrity()});
					});
				");
			}
			else if ($this->_mootool_version == '1.2')
			{
				$doc->addScriptDeclaration("
					function checkIntegrity()
					{
						$('jsn-check-integrity').set('html', '');
						$('jsn-check-integrity-result').set('html', '');
						var actionIntegrityUrl = '".JURI::root()."index.php';

						var resultIntegrityMsg = new Element('span');
						resultIntegrityMsg.set('class','jsn-integrity-checking');
						resultIntegrityMsg.set('html','".JText::_('CHECKING', true)."');
						resultIntegrityMsg.inject($('jsn-check-integrity-result'));

						var jsonRequest = new Request.JSON({url: actionIntegrityUrl, onSuccess: function(jsonObj){
							if(jsonObj.integrity == '1') {
								resultIntegrityMsg.set('class','jsn-modification-exist');
								resultIntegrityMsg.set('html','<span>".JText::_('SOME_FILES_HAVE_BEEN_MODIFIED', true).". <a href=\"../index.php?template=".$template_name."&tmpl=jsn_listmodifiedfiles\" class=\"link-action\" id=\"see-file-details\" rel=\"{handler: \'iframe\', size: {x: 570, y:320}}\" onclick=\"SqueezeBox.addClick($(\'see-file-details\')); SqueezeBox.fromElement($(\'see-file-details\')); return false;\">".JText::_('SEE_DETAILS_FILE', true)."</a></span>');
							} else if (jsonObj.integrity == '0') {
								resultIntegrityMsg.set('class','jsn-no-modification');
								resultIntegrityMsg.set('html','".JText::_('NO_FILES_MODIFICATION_FOUND', true)."');
							} else {
								resultIntegrityMsg.set('class','jsn-no-modification');
								resultIntegrityMsg.set('html','".JText::_('NO_CHECKSUM_FILE_FOUND', true)."');
							}
							resultIntegrityMsg.inject($('jsn-check-integrity-result'));
						}}).get({'template': '".$template_name."', 'tmpl': 'jsn_runajax', 'task': 'checkFilesIntegrity'});
					}

					window.addEvent('domready', function(){
					   $('jsn-check-version').set('html', '');
						var actionVersionUrl = '".JURI::root()."index.php';
						var resultVersionMsg = new Element('span');
						resultVersionMsg.set('class','jsn-version-checking');
						resultVersionMsg.set('html',' - ".JText::_('CHECKING_VERSION', true)."');
						resultVersionMsg.inject($('jsn-check-version-result'));
						var jsonRequest = new Request.JSON({url: actionVersionUrl, onSuccess: function(jsonObj){
							if(jsonObj.connection && jsonObj.version != '') {
								if(jsonObj.version == '".$this->_template_version."') {
									resultVersionMsg.set('class','jsn-latest-version');
									resultVersionMsg.set('html','');
								} else {
									resultVersionMsg.set('class','jsn-outdated-version');
									resultVersionMsg.set('html',' - <a href=\"../index.php?template=".$template_name."&tmpl=jsn_autoupdater\" class=\"link-action\" id=\"jsn-auto-update\" rel=\"{handler: \'iframe\', size: {x: 750, y:680}}\" onclick=\"SqueezeBox.fromElement($(\'jsn-auto-update\'), {parse: \'rel\'}); return false;\">".JText::_('UPDATE_NOW', true)." '+jsonObj.version+'</a>');
								}
							} else {
								resultVersionMsg.set('class','jsn-connection-fail');
								resultVersionMsg.set('html',' <span class=\"grey\">-</span> ".JText::_('CONNECTION_FAILED', true)."');
							}
							resultVersionMsg.inject($('jsn-check-version-result'));
						}}).get({'template': '".$template_name."', 'tmpl': 'jsn_runajax', 'task': 'checkVersion'});
						$('jsn-check-integrity').addEvent('click', function() {checkIntegrity()});
					});

				");
			}

		$tell_more = '<p>'.JText::_('UPGRADE_TO_PRO').'</p>';

		$exploded_template_name = explode('_', $template_name);
		if(strstr($this->_template_copyright, $this->_template_author) === false)
		{
			$copyright = $this->_template_copyright. ' (<a target="_blank" title="'.$this->_template_author.'" href="'.$this->_template_author_url.'">'.$this->_template_author.'</a>)';
		}
		else
		{
			$copyright = str_replace($this->_template_author, '<a target="_blank" title="'.$this->_template_author.'" href="'.$this->_template_author_url.'">'.$this->_template_author.'</a>', $this->_template_copyright);
		}
		$staticLink    			= $this->_template_author_url.'/joomla-templates/'.@$exploded_template_name[0].'-'.@$exploded_template_name[1].'.html';

		$html = '</td></tr><tr class="jsn-about"><td>';
		$html .= '<div class="jsn-about-inner-div">';
		$html .= '<table><tr><td width="10" valign="top"><div class="jsn-template-thumbnail">';
		$html .= '<img src ="../templates/'.$this->_template_folder_name.'/template_thumbnail.png" width="206" height="150" />';
		$html .= '</div></td><td><div class="jsn-template-details">';
		$html .= '<h2>'.JString::str_ireplace('_', ' ', $this->_template_name).' '.$this->_template_edition;
		if ($proExists === false)
		{
			$html .= '<a class="link-button jsn-modal button-inside-h2" rel="{handler: \'iframe\', size: {x: 750, y: 650}}" href="../index.php?template='.JString::strtolower($this->_template_name).'&tmpl=jsn_upgrade"><span class="icon-proversion">'.JText::_('JSN_UPGRADE_TEMPLATE').'</span></a>';
		}
		$html .= '</h2>'.$tell_more.'<hr />';
		$html .= '<dl>';
		$html .= '<dt>'.JText::_('VERSION').':</dt><dd><strong class="jsn-current-version">'.$this->_template_version.'</strong><a href="javascript:void(0);" class="link-action" id="jsn-check-version"></a><span id="jsn-check-version-result"></span></dd>';
		$html .= '<dt>'.JText::_('COPYRIGHT').':</dt><dd>'.$copyright.'</dd>';
		$html .= '<dt>'.JText::_('INTEGRITY').':</dt><dd><a href="javascript:void(0);" class="link-action" id="jsn-check-integrity">'.JText::_('CHECK_FOR_FILES_MODIFICATION').'</a><span id="jsn-check-integrity-result"></span></dd>';
		$html .= '</dl>';
		$html .= '</div></td></tr></table><div class="jsn-product-cta">';
		$html .= '<div style="float: left; width: 60%;"><ul class="horizontal-list"><li><a rel="{handler: \'iframe\', size: {x: 640, y: 510}}" href="'.$this->_template_author_url.'/'.@$exploded_template_name[2].'-joomla-templates-promo.html" class="link-button jsn-modal"><span class="icon-gallery">'.JText::_('SEE_OTHER_TEMPLATES').'</span></a></li></ul></div>';
		$html .= '<div style="float: right; text-align: right;"><ul class="horizontal-list">';
		$html .= '<li><a target="_blank" title="Connect with us on Facebook" class="" href="http://www.facebook.com/joomlashine"><img width="24" height="24" alt="Connect with us on Facebook" src="' . JURI::root() . 'templates/' . JString::strtolower($this->_template_name) . '/admin/images/icon-facebook.png"></a></li>';
		$html .= '<li><a target="_blank" title="Follow us on Twitter" class="" href="http://twitter.com/joomlashine"><img width="24" height="24" alt="Follow us on Twitter" src="' . JURI::root() . 'templates/' . JString::strtolower($this->_template_name) . '/admin/images/icon-twitter-24.png"></a></li>';
		$html .= '</ul></div>';
		$html .= '</td></tr>';

		return $html;
	}

	function jsnPositionMapping()
	{
		jimport('joomla.filesystem.file');
		$disabled 	= ($this->_node->attributes('disabled') ? 'disabled="'.$this->_node->attributes('disabled').'"' : '');
		$default 	= ($this->_node->attributes('default')) ? $this->_node->attributes('default') : '';
		$ini 		= $this->_template_folder_path.DS.'params.ini';
		$xml		= $this->_template_folder_path.DS.'templateDetails.xml';

		if (JFile::exists($ini))
		{
			$content = JFile::read($ini);
		}
		else
		{
			$content = null;
		}

		if ($this->_cacheSensitive && $this->_node->attributes('cachesensitive') == 'yes') $disabled = ' disabled="disabled"';

		$params 		= new JParameter($content, $xml, 'template');
		$data 			= $this->_obj_utils->getPositions($this->_template_folder_name);
		$html 			= '<div class="jsn-positionmapping">';

		if($this->_value) {
			$html   .= $this->_obj_utils->renderPositionComboBox($this->_value, $data['desktop'], 'params['.$this->_name.']', $disabled);
		} else {
			$html   .= $this->_obj_utils->renderPositionComboBox($default, $data['desktop'], 'params['.$this->_name.']', $disabled);
		}
		$html 	.= '</div>';
		return $html;
	}

	function jsnMedia()
	{
		$size 		= ($this->_node->attributes('size') ? 'size="'.$this->_node->attributes('size').'"' : '');
		$class 		= 'class="'. ($this->_node->attributes('class') ? $this->_node->attributes('class') : 'text_area').' jsn-readonly"';
		$disabled 	= ($this->_node->attributes('disabled') ? true : false);
		
		if ($this->_cacheSensitive && $this->_node->attributes('cachesensitive') == 'yes') $disabled = ' disabled="disabled"';

		$unactived  	= ($disabled) ? ' jsn-disabled-button' : '';
		$disabledInput  = ($disabled) ? 'disabled="disabled"' : '';
		$linkText   	= JText::_('SELECT');
		$value			= htmlspecialchars(html_entity_decode($this->_value, ENT_QUOTES), ENT_QUOTES);
		$modalURL		= 'index.php?option=com_media&view=images&tmpl=component&e_name='.$this->_control_name.$this->_name;
		$e_name			= $this->_control_name.$this->_name;
		$js				= '<script type="text/javascript">'."\n".'
						function jInsertEditorText(text, editor)'."\n".'
						{
							if(text != "")
							{
								reg = /src="(.*?)"/i;
								var tmpText = text.match(reg);'."\n".'
								'."\n".'document.getElementById(editor).value = tmpText[1];'."\n".'
							}
						}'."\n".'</script>';
		if($disabled)
		{
			$link 	= '<a class="link-button jsn-disabled-button" href="javascript:void(0);">'.$linkText.'</a>';
		}
		else
		{
			$link 	= $this->_buildModalWindow($linkText, $modalURL);
		}
		return $js.'<input type="text" name="'.$this->_control_name.'['.$this->_name.']" id="'.$e_name.'" value="'.$value.'" '.$class.' '.$size.' '.$disabledInput.' readonly="readonly" />'.$link.'<a href="javascript: void(0);" class="link-button'.$unactived.'" onclick="document.getElementById(\''.$e_name.'\').value=\'\';">'.JText::_('CLEAR').'</a>';
	}
}
?>