<?php
/**
 * @author    JoomlaShine.com http://www.joomlashine.com
 * @copyright Copyright (C) 2008 - 2011 JoomlaShine.com. All rights reserved.
 * @license   GNU/GPL v2 http://www.gnu.org/licenses/gpl-2.0.html
 */

defined('_JEXEC' ) or die('Restricted access');
jimport('joomla.filesystem.file');
jimport('joomla.filesystem.folder');
class JSNReadXMLFile
{
	var $_template_folder_path  = '';
	var $_template_folder_name 	= '';

	function JSNReadXMLFile()
	{
		$this->_setPhysicalTmplInfo();
	}

	function _setPhysicalTmplInfo()
	{
		$template_name 					= explode(DS, str_replace(array('\includes\lib', '/includes/lib'), '', dirname(__FILE__)));
		$template_name 					= $template_name [count( $template_name ) - 1];
		$path_base 						= str_replace(DS."templates".DS.$template_name.DS.'includes'.DS.'lib', "", dirname(__FILE__));
		$this->_template_folder_name    = $template_name;
		$this->_template_folder_path 	= $path_base.DS.'templates'.DS.$template_name;
	}

	function parseTemplateXmlFile()
	{
		$file_name    = 'templateDetails.xml';
		$array_result = array();
		$file_details = $this->_template_folder_path.DS.$file_name;
		
		$xml_parser   = JFactory::getXMLParser('Simple');
		
		if (!$xml_parser->loadFile($file_details)) {
			return false;
		} else {
			return $xml_parser->document;
		}
	}

	function getTemplateInfo()
	{
		$xml_document = $this->parseTemplateXmlFile();

		if (!$xml_document || !is_object($xml_document)) {
			return false;
		}

		if ($xml_document->name() != 'mosinstall' && $xml_document->name() != 'install') {
			return false;
		}

		$data = new stdClass();

		$data->directory = $this->_template_folder_name;
		$data->checked_out = 0;

		$data->type = $xml_document->attributes('type') ? $xml_document->attributes('type') : '';
		if ($data->type != 'template') {
			return false;
		}
		
		$element = $xml_document->getElementByPath('name');
		$data->name = $element ? $element->data() : '';
		unset($element);

		$element = $xml_document->getElementByPath(strtolower('creationDate'));
		$data->creationDate = $element ? $element->data() : JText::_('Unknown');
		unset($element);

		$element = $xml_document->getElementByPath('author');
		$data->author = $element ? $element->data() : JText::_('Unknown');
		unset($element);

		$element = $xml_document->getElementByPath('copyright');
		$data->copyright = $element ? $element->data() : '';
		unset($element);

		$element = $xml_document->getElementByPath(strtolower('authorEmail'));
		$data->authorEmail = $element ? $element->data() : '';
		unset($element);

		$element = $xml_document->getElementByPath(strtolower('authorUrl'));
		$data->authorUrl = $element ? $element->data() : '';
		unset($element);

		$element = $xml_document->getElementByPath('version');
		$data->version = $element ? $element->data() : '';
		unset($element);

		$element = $xml_document->getElementByPath('edition');
		$data->edition = $element ? $element->data() : '';
		unset($element);

		$element = $xml_document->getElementByPath('license');
		$data->license = $element ? $element->data() : '';
		unset($element);

		$element = $xml_document->getElementByPath('description');
		$data->description = $element ? $element->data() : '';
		unset($element);

		$element = $xml_document->getElementByPath('group');
		$data->group = $element ? $element->data() : '';
		unset($element);
	
 		$data->mosname 		= JString::strtolower(str_replace(' ', '_', $data->name));

		return $data;
	}

	function getTemplateManifestFileInformation()
	{
		$array_result = array();

		$document_details = $this->parseTemplateXmlFile();
		if (!$document_details || !is_object($document_details)) {
			return $array_result;
		}
		
		$nod_name 	 			= $document_details->getElementByPath('name');

		if ($nod_name)
		{
			$arr_name 							= explode('_', $nod_name->data());
			$array_result['name'] 				= strtolower(@$arr_name[0].'_'.@$arr_name[1]);
			$array_result['name_uppercase'] 	= @$arr_name[0].' '.@$arr_name[1];
			$array_result['full_name'] 			= @$arr_name[0].'_'.@$arr_name[1].'_'.@$arr_name[2];
		}

		$nod_version 	 							= $document_details->getElementByPath('version');
		if ($nod_version) $array_result['version']  = $nod_version->_data;

		$nod_edition 	 							= $document_details->getElementByPath('edition');
		if ($nod_edition)
		{
			$array_result['edition'] = strtolower($nod_edition->_data);
		}
		else
		{
			$array_result['edition'] = '';
		}

		return $array_result;
	}

	function getExtensionManifestFileInformation($name, $value)
	{
		$data = array();

		if($value['manifest_path'] == '') return $data;

		$file_details = JPATH_ROOT.DS.str_replace('/', DS, $value['manifest_path']);

		if ($name == 'imageshow')
		{
			if (!JFile::exists($file_details))
			{
				$file_details	= JPATH_ADMINISTRATOR.DS.'components'.DS.'com_'.$name.DS.'com_'.$name.'.xml';
			}
		}

		$xml = JFactory::getXMLParser('Simple');

		if (!$xml->loadFile($file_details))
		{
			unset($xml);
			return $data;
		}
		$element		 = $xml->document->version[0];
		$data['version'] = $element ? $element->data() : '';
		return 	$data;
	}

	function getSampleDataFileInfomation($path)
	{
		$array_result 		= array();
	    $template_manifest	= $this->getTemplateManifestFileInformation();
		$xml_file			= $template_manifest['name'].'_sample_data.xml';
	    $xml 	            = JFactory::getXMLParser('Simple');
		$path 	            = JPath::clean($path.DS.$xml_file);
		if (!$xml->loadFile($path))
		{
			unset($xml);
			return false;
		}
		$document   				= $xml->document;
		$attributes 				= $document->attributes();
		$array_result ['name'] 		= trim(strtolower($attributes['name']));
		$array_result ['version'] 	= trim(strtolower($attributes['version']));
		return $array_result;
	}

	function getSampleDataFileContent($path)
	{
		$template_manifest	= $this->getTemplateManifestFileInformation();
		$xml_file			= $template_manifest['name'].'_sample_data.xml';
		$xml 				= JFactory::getXMLParser('Simple');
		$path 				= JPath::clean($path.DS.$xml_file);

		if (!$xml->loadFile($path))
		{
			unset($xml);
			return false;
		}

		$array_obj 	= array();
		$document 	= $xml->document;

		foreach($document->children() as $child)
		{
			$array_backup 			= array();
			$array_query 			= array();
			$obj 					= new stdClass();
			$attributes 			= $child->attributes();
			$obj->name 				= trim(strtolower($attributes['name']));
			$obj->version 			= (isset($attributes['version'])?$attributes['version']:'');
			$obj->author 			= (isset($attributes['author'])?$attributes['author']:'');
			$obj->manifest_path 	= (isset($attributes['manifest_path'])?$attributes['manifest_path']:'');
			$obj->description 		= (isset($attributes['description'])?$attributes['description']:'');

			foreach ($child->children() as $task)
			{
				$attributes_task = $task->attributes();

				if($attributes_task ["name"] == 'dbbackup')
				{
					foreach ($task->children() as $parameters)
					{
						foreach ($parameters->children() as $parameter)
						{
							$array_backup[] = $parameter->data();

						}
					}
				}
				if($attributes_task ["name"] == 'dbinstall')
				{
					foreach ($task->children() as $parameters)
					{
						foreach ($parameters->children() as $parameter)
						{
							$array_query[] = $parameter->data();
						}
					}
				}
			}

			$obj->backup 	= $array_backup;
			$obj->queries 	= $array_query;
			$array_obj [$attributes['name']] = $obj;
		}
		return $array_obj;
	}
}
